#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"init.h"
#include	"pool.h"

Mach	*m;
Proc	*up;
Conf	conf;
int 	noprint;
int serialpost = 0;

void
ledpost(int val) {
	*(unsigned long *)0x11e00080 = val;
}
extern void debugputc(unsigned int val);

void put4(unsigned int nibl) {
	nibl &= 0xf;

	if (nibl > 9){
		nibl -= 10;
		nibl += 'A';
	}
	else
		nibl += '0';

	debugputc(nibl);
}

void put8(unsigned int c) {
	put4(c>>4);
	put4(c);
}

void put16(unsigned int word) {
	put8(word>>8);
	put8(word);
}

void put32(unsigned int dword){
	put16(dword>>16);
	put16(dword);
}

void poststr(char *s) {
	while(*s){
		if (*s == '\n')
			debugputc('\r');
		debugputc(*s);

		s++;
	}
}

void poststrn(char *s, int n) {
	while (n-- > 0){
		if (*s == '\n')
			debugputc('\r');
		debugputc(*s);

		s++;
	}
}

void
post(unsigned int val) {
	static unsigned char hex[] = "0123456789ABCDEF";
	if (serialpost) {
		debugputc( hex[(val>>4)&15]);
		debugputc( hex[val&15]);
		poststr("\n");
	}
	*(unsigned long *)0x11e00080 = val;

}


/* see ../port/devsd.c. This should not need to exist */
int pcmspecial(char*,ISAConf*){
	return -1;
}

void
idlehands(void)
{
	char *msgb = "idlehands called with splhi\n";
	char *msga = "doze returns with splhi\n";

	if(!islo()){
		uartputs(msga, strlen(msga));
		spllo();
	}
	doze();
	if(!islo()){
		uartputs(msgb, strlen(msgb));
		spllo();
	}
}

int fucked = 0x55aaddff;

char *s="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

void
where(int i){
	unsigned long pc = getcallerpc(&i);
	poststr("pc is "); put32(pc); poststr("\n");
}

void
main(void)
{
	unsigned long *lp;
	cacheflush();
	debugputc('S');
	put4(0xf); debugputc('\n');
	put8(0xfe);debugputc('\n');
	put16(0x1234);debugputc('\n');
	put32(0xdeadbeef);debugputc('\n');
	where(1);
#ifdef YA
	for(lp = 0; lp < (unsigned long *) 0xc0200000; lp++) {
		unsigned long l = (unsigned long) lp;
		if ((l & 0xffff) == 0){
			debugputc('\n');
			put32(l);
			debugputc(':');
		}
		if (*lp == 0x55aaddff){
			put32(l);
			debugputc('\n');
		}
	}
#endif
			

	if (fucked != 0x55aaddff) {
		debugputc('B');		debugputc('a');
		debugputc('d');		debugputc('\n');
	}
	if (fucked == 0x55aaddff) {
		debugputc('G');		debugputc('u');
		debugputc('d');		debugputc('\n');
	}




	//	debugputc('E');
	ledpost(0xdf);
	mmuinvalidate();
	ledpost(0xde);
	
	/* zero out bss */
	memset(edata, 0, end-edata);
//	debugputc('H');
	debugputc(s[20]);
	debugputc('\n');
	post(0xdd);
	/* point to Mach structure */
	m = (Mach*)MACHADDR;
	memset(m, 0, sizeof(Mach));
	m->ticks = 1;
	post(0xdc);
	active.machs = 1;
	debugputc('I');
	quotefmtinstall();
	post(0xdb);
	poststr("before plan 9 iprint\n");
	iprint("\nPlan 9 ts7200 kernel\n");
	post(0xda);
	confinit();
	post(0xd9);
	xinit();
	post(0xd8);
	mmuinit();
	post(0xd7);
	machinit();
	post(0xd6);
	trapinit();
	poststr("done trapinit?\n");
	post(0xd5);
	poststr("done trapinit ... call uart setup\n");
	
	sa930x_uartsetup();
//	dmainit();
//	screeninit();
	poststr("done uart setup ...\n");
	printinit();	/* from here on, print works, before this we need iprint */
	post(0xd4);
	clockinit();
	post(0xd3);
	procinit0();
	post(0xd2);
	initseg();
	post(0xd1);
	links();
	post(0xd0);
	chandevreset();
	post(0xcf);
	poststr("pageinit\n");
	pageinit();
	post(0xce);
	poststr("call swapinit\n");
	swapinit();
	post(0xcd);
	poststr("call user init\n");
	userinit();
	post(0xcc);
	poststr("call schedinit\n");
	schedinit();
	post(0xcb);
}

/* need to do better */
void
reboot(void*, void*, ulong)
{
	exit(0);
}


/*
 *  exit kernel either on a panic or user request
 */
void
exit(int ispanic)
{
	void (*f)(void);

	USED(ispanic);
	delay(1000);

	iprint("it's a wonderful day to die\n");
	cacheflush();
	mmuinvalidate();
	mmudisable();
	f = nil;
	(*f)();
}

static uchar *sp;

/*
 *  starting place for first process
 */
void
init0(void)
{
	extern int watchtrap;
	up->nerrlab = 0;
	iprint("init0!\n");
	post(0x15);
	spllo();
	post(0x16);
	iprint("after spllo in init0\n");
	print("try a print\n");
	/*
	 * These are o.k. because rootinit is null.
	 * Then early kproc's will have a root and dot.
	 */
	up->slash = namec("#/", Atodir, 0, 0);
	cnameclose(up->slash->name);
	up->slash->name = newcname("/");
	up->dot = cclone(up->slash);
	iprint("all done teh namec stuff \n");
	chandevinit();
	iprint("all done teh chandevinit stuff \n");
	if(!waserror()){
		iprint("We're in the waserror() block\n");
		ksetenv("terminal", "ts7200", 0);
		ksetenv("cputype", "arm", 0);
		if(cpuserver)
			ksetenv("service", "cpu", 0);
		else
			ksetenv("service", "terminal", 0);
		poperror();
	}
	iprint("START A KPROC ..., islo() is 0x%lux\n", islo());
	kproc("alarm", alarmkproc, 0);
	iprint("ALL DONE STRTIN THE KPROC, isloc is 0x%lux\n", islo());
	iprint("Let's go see the user!\n");
	touser(sp);
	watchtrap = 1;
	iprint("We're BAIK from seeing the user I guess. islo 0x%lux\n", islo());
}

/*
 *  pass boot arguments to /boot
 */
static uchar *
pusharg(char *p)
{
	int n;

	n = strlen(p)+1;
	sp -= n;
	memmove(sp, p, n);
	return sp;
}
static void
bootargs(ulong base)
{
 	int i, ac;
	uchar *av[32];
	uchar *bootpath;
	uchar **lsp;

	/*
 	 *  the sizeof(Sargs) is to make the validaddr check in
	 *  trap.c's syscall() work even when we have less than the
	 *  max number of args.
	 */
	sp = (uchar*)base + BY2PG - sizeof(Sargs);

	bootpath = pusharg("/boot/boot");
	ac = 0;
	av[ac++] = pusharg("boot");

	/* 4 byte word align stack */
	sp = (uchar*)((ulong)sp & ~3);

	/* build argc, argv on stack */
	sp -= (ac+1)*sizeof(sp);
	lsp = (uchar**)sp;
	for(i = 0; i < ac; i++)
		*lsp++ = av[i] + ((USTKTOP - BY2PG) - base);
	*lsp = 0;

	/* push argv onto stack */
	sp -= BY2WD;
	lsp = (uchar**)sp;
	*lsp = sp + BY2WD + ((USTKTOP - BY2PG) - base);

	/* push pointer to "/boot" */
	sp -= BY2WD;
	lsp = (uchar**)sp;
	*lsp = bootpath + ((USTKTOP - BY2PG) - base);

	/* leave space for where the initcode's caller's return PC would normally reside */
	sp -= BY2WD;

	/* relocate stack to user's virtual addresses */
	sp += (USTKTOP - BY2PG) - base;
}

/*
 *  create the first process
 */
void
userinit(void)
{
	Proc *p;
	Segment *s;
	KMap *k;
	Page *pg;

	/* no processes yet */
	up = nil;

	p = newproc();
	iprint("newproc, p is %p\n", p);

	p->pgrp = newpgrp();
	p->egrp = smalloc(sizeof(Egrp));
	p->egrp->ref = 1;
	p->fgrp = dupfgrp(nil);
	p->rgrp = newrgrp();
	p->procmode = 0640;

	kstrdup(&eve, "");
	kstrdup(&p->text, "*init*");
	kstrdup(&p->user, eve);

	/*
	 * Kernel Stack
	 */
	p->sched.pc = (ulong)init0;
	p->sched.sp = (ulong)p->kstack+KSTACK-(sizeof(Sargs)+BY2WD);

	/*
	 * User Stack
	 */
	s = newseg(SG_STACK, USTKTOP-USTKSIZE, USTKSIZE/BY2PG);
	p->seg[SSEG] = s;
	pg = newpage(1, 0, USTKTOP-BY2PG);
	segpage(s, pg);
	k = kmap(pg);
	iprint("kmap for stack k is %p\n", k);
	bootargs(VA(k));
	kunmap(k);

	/*
	 * Text
	 */
	s = newseg(SG_TEXT, UTZERO, 1);
	p->seg[TSEG] = s;
	pg = newpage(1, 0, UTZERO);
	memset(pg->cachectl, PG_TXTFLUSH, sizeof(pg->cachectl));
	segpage(s, pg);
	k = kmap(s->map[0]->pages[0]);
	iprint("kmap for text is %p\n", k);
	memmove((ulong*)VA(k), initcode, sizeof initcode);
	kunmap(k);

	ready(p);
	iprint("schedinit after ready, up is %p, islo 0x%lux\n", up, islo());
}

/*
 *  set mach dependent process state for a new process
 */
void
procsetup(Proc *p)
{
	p->fpstate = FPinit;
}

/*
 *  Save the mach dependent part of the process state.
 */
void
procsave(Proc *p)
{
	USED(p);
}

/* place holder */
/*
 *  dummy since rdb is not included 
 */
void
rdb(void)
{
}

/*
 *  probe the last location in a meg of memory, make sure it's not
 *  reflected into something else we've already found.
 */
int
probemem(ulong addr)
{
	ulong *p;
	ulong a;

	addr += OneMeg - sizeof(ulong);
	p = (ulong*)addr;
	*p = addr;
	for(a = conf.base0+OneMeg-sizeof(ulong); a < conf.npage0; a += OneMeg){
		p = (ulong*)a;
		*p = 0;
	}
	for(a = conf.base1+OneMeg-sizeof(ulong); a < conf.npage1; a += OneMeg){
		p = (ulong*)a;
		*p = 0;
	}
	p = (ulong*)addr;
	if(*p != addr)
		return -1;
	return 0;
}

/*
 *  we assume that the kernel is at the beginning of one of the
 *  contiguous chunks of memory.
 */
void
confinit(void)
{
	int i;
	ulong addr;
	ulong ktop;

	/* find first two contiguous sections of available memory */
	addr = 0;
	conf.base0 = conf.npage0 = addr;
	conf.base1 = conf.npage1 = addr;
	conf.base0 = addr + 0x400000;
	conf.npage0 = addr + 8*1024*1024;
	conf.base1 = conf.npage1 = 0;
/**/
	conf.base1 = addr + 16*1024*1024;
	conf.npage1 = addr + 24*1024*1024;;/**/
#ifdef YAHRIGHT
	for(i = 0; i < 512; i++){
		if(probemem(addr) == 0)
			break;
		addr += OneMeg;
	}
	for(; i < 512; i++){
		if(probemem(addr) < 0)
			break;
		addr += OneMeg;
		conf.npage0 = addr;
	}

	conf.base1 = conf.npage1 = addr;
	for(; i < 512; i++){
		if(probemem(addr) == 0)
			break;
		addr += OneMeg;
	}
	for(; i < 512; i++){
		if(probemem(addr) < 0)
			break;
		addr += OneMeg;
		conf.npage1 = addr;
	}
#endif
#ifdef YA
	/* take kernel out of allocatable space */
	ktop = PGROUND((ulong)end);
	if(ktop >= conf.base0 && ktop <= conf.npage0)
		conf.base0 = ktop;
	else if(ktop >= conf.base1 && ktop <= conf.npage1)
		conf.base1 = ktop;
	else
		iprint("kernel not in allocatable space\n");
#endif

	/* zero memory */
	debugputc('Z');
	put32(conf.base0);debugputc('\n');
	put32(conf.npage0);debugputc('\n');
	put32(conf.base1);debugputc('\n');
	put32(conf.npage1);debugputc('\n');

	memset((void*)conf.base0, 0, conf.npage0 - conf.base0);
	debugputc('y');
	memset((void*)conf.base1, 0, conf.npage1 - conf.base1);
	debugputc('z');

	/* make npage the right thing */
	conf.npage0 = (conf.npage0 - conf.base0)/BY2PG;
	conf.npage1 = (conf.npage1 - conf.base1)/BY2PG;
	conf.npage = conf.npage0+conf.npage1;

	if(conf.npage > 16*MB/BY2PG){
		conf.upages = (conf.npage*60)/100;
		imagmem->minarena = 4*1024*1024;
	}else
		conf.upages = (conf.npage*40)/100;
	conf.ialloc = ((conf.npage-conf.upages)/2)*BY2PG;

	/* only one processor */
	conf.nmach = 1;

	/* set up other configuration parameters */
	conf.nproc = 100;
	conf.nswap = 0; conf.npage*3;
	conf.nswppo = 4096;
	conf.nimage = 200;

	conf.monitor = 1;

	conf.copymode = 0;		/* copy on write */
	debugputc('c');
}
/*
GPIOregs *gpioregs;
ulong *egpioreg = (ulong*)EGPIOREGS;
PPCregs *ppcregs;
MemConfRegs *memconfregs;
PowerRegs *powerregs;
ResetRegs *resetregs;
*/
/*
 *  configure the machine
 */
void
machinit(void)
{
#ifdef YEAHRIGHT
	/* set direction of SA1110 io pins and select alternate functions for some */
	gpioregs = mapspecial(GPIOREGS, sizeof(GPIOregs));
	gpioregs->direction = 
		GPIO_LDD8_o|GPIO_LDD9_o|GPIO_LDD10_o|GPIO_LDD11_o
		|GPIO_LDD12_o|GPIO_LDD13_o|GPIO_LDD14_o|GPIO_LDD15_o
		|GPIO_CLK_SET0_o|GPIO_CLK_SET1_o
		|GPIO_L3_SDA_io|GPIO_L3_MODE_o|GPIO_L3_SCLK_o
		|GPIO_COM_RTS_o;
	gpioregs->rising = 0;
	gpioregs->falling = 0;
	gpioregs->altfunc |= 
		GPIO_LDD8_o|GPIO_LDD9_o|GPIO_LDD10_o|GPIO_LDD11_o
		|GPIO_LDD12_o|GPIO_LDD13_o|GPIO_LDD14_o|GPIO_LDD15_o
		|GPIO_SSP_CLK_i;

	/* map in special H3650 io pins */
	egpioreg = mapspecial(EGPIOREGS, sizeof(ulong));

	/* map in peripheral pin controller (ssp will need it) */
	ppcregs = mapspecial(PPCREGS, sizeof(PPCregs));

	/* SA1110 power management */
	powerregs = mapspecial(POWERREGS, sizeof(PowerRegs));

	/* memory configuraton */
	memconfregs = mapspecial(MEMCONFREGS, sizeof(MemConfRegs));

	/* reset controller */
	resetregs = mapspecial(RESETREGS, sizeof(ResetRegs));
#endif
}

#ifdef YEAHRIGHT

/*
 *  manage egpio bits
 */
static ulong egpiosticky;

void
egpiobits(ulong bits, int on)
{
	if(on)
		egpiosticky |= bits;
	else
		egpiosticky &= ~bits;
	*egpioreg = egpiosticky;
}

void
rs232power(int on)
{
	egpiobits(EGPIO_rs232_power, on);
	delay(50);
}

void
audioamppower(int on)
{
	egpiobits(EGPIO_audio_power, on);
	delay(50);
}

void
audioicpower(int on)
{
	egpiobits(EGPIO_audio_ic_power, on);
	delay(50);
}

void
irpower(int on)
{
	egpiobits(EGPIO_ir_power, on);
	delay(50);
}

void
lcdpower(int on)
{
	egpiobits(EGPIO_lcd_3v|EGPIO_lcd_ic_power|EGPIO_lcd_5v|EGPIO_lcd_9v, on);
	delay(50);
}

void
flashprogpower(int on)
{
	egpiobits(EGPIO_prog_flash, on);
}
#endif
/* here on hardware reset */
void
resettrap(void)
{
}

/*
 *  for drivers that used to run on x86's
 */
void
outb(ulong a, uchar v)
{
	*(uchar*)a = v;
}
void
outs(ulong a, ushort v)
{
	*(ushort*)a = v;
}
void
outss(ulong a, void *p, int n)
{
	ushort *sp = p;

	while(n-- > 0)
		*(ushort*)a = *sp++;
}
void
outl(ulong a, ulong v)
{
	*(ulong*)a = v;
}
uchar
inb(ulong a)
{
	return *(uchar*)a;
}
ushort
ins(ulong a)
{
	return *(ushort*)a;
}
void
inss(ulong a, void *p, int n)
{
	ushort *sp = p;

	while(n-- > 0)
		*sp++ = *(ushort*)a;
}
ulong
inl(ulong a)
{
	return *(ulong*)a;
}

char*
getconf(char*)
{
	return nil;
}

long
_xdec(long *p)
{
	int x;
	long v;

	x = splhi();
	v = --*p;
	splx(x);
	return v;
}

void
_xinc(long *p)
{
	int x;
	post(0x80);
	x = splhi();
	post(0x81);
	++*p;
	post(0x82);
	splx(x);
	post(0x83);
}
